#!/usr/local/bin/perl

# ranking.cgi 
# Kabako (TabaTech)
# http://www.biwa.ne.jp/~tabatan/

#$ver="ver1.0 (2002/04/10)";	# zzpLOCGI
$ver="ver1.1 (2004/12/14)";	# őo^

require './jcode.pl';

$logfile="score/ranking.txt";

$MAX = 100; 	#ver1.1

get_query();
header();
get_time();

# Of[^̓ǂݍ
get_log();

if($qs{SCORE}) {
    add_score();
}else{
	# \̕\
	show_table_head();
	show_table();
	show_table_foot();
	footer();
}

# o^
sub add_score {
	$add_line = "$qs{NAME}\t$qs{SCORE}\t$datename\t$timename\t$qs{COMMENT}\t$ENV{'HTTP_REFERER'}\n";

	push(@lines, $add_line);
	@lines = sort cmp_score @lines;

	if ($#lines >= $MAX){		#ver1.1
		$remove = $#lines - $MAX +1;
		splice @lines,-$remove,$remove;
	}

#	open(ADD, ">>$logfile");
#	print ADD "$add_line\n";

	open(ADD, ">$logfile");
	print ADD @lines;
	close(ADD);
}

# HTML̃wb_[o
sub header {
	print "Content-type: text/html\n\n";
    print <<"EOF";
<HTML>
<HEAD>
<TITLE>XRALO</TITLE>
</HEAD>
<BODY bgcolor="#EEFFEE">
EOF
}
# HTML̃tb^[[o
sub footer {
    print <<"EOF";
</BODY>
</HTML>
EOF
}

sub get_query {
    # NG[̓`FbN
    if($ENV{'REQUEST_METHOD'} eq 'GET') {
	#$query = $ENV{'QUERY_STRING'};
	return; 	# GETo^s
    } elsif($ENV{'REQUEST_METHOD'} eq 'POST') {
	read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
    }

    local(@query) = split(/&/,$query);
    foreach (@query) {
        ($key,$val) = split(/=/);
        $val =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c",hex($1))/ge;

	# ^O
	$val =~ s/</\&lt\;/g;
	$val =~ s/>/\&gt\;/g;
	$val =~ s/\"/\&quot\;/g;

        $qs{$key} = $val;

	# R[hϊ
	&jcode::convert(*val,'sjis');
    }
}

# Of[^̓ǂݍ
sub get_log {
    @lines = ();
    open(IN, "$logfile") || print "Ot@CI[vł܂\n";
    @lines = <IN>;
    close(IN);
    @lines = sort cmp_score @lines;
}

sub cmp_score {
    ($name1, $score1, $date1, $time1, $com1) = split('\t', $a);
    ($name2, $score2, $date2, $time2, $com2) = split('\t', $b);
    $score2 <=> $score1 || $date2 cmp $date1 || $time2 cmp $time1;
}

# \̃wb_[\
sub show_table_head {
    print <<"EOF";
<DIV align="center">
<STRONG><FONT size=+1>XRALO</FONT></STRONG><BR>
<BR>
<TABLE border="1" bgcolor="#C0C0C0">
    <TR bgcolor="#C0C0FF">
        <TD align="center"></TD>
        <TD align="center">O</TD>
        <TD align="center">_</TD>
        <TD align="center">ЂƂ</TD>
        <TD align="center">t</TD>
    </TR>
EOF
}

# \̓e\
sub show_table {

    @lines = sort cmp_score @lines;
    $num=0;
    foreach $line (@lines) {
	@line = split('\t', $line);
	($name, $score, $date, $time, $com) = @line;

	$bg_color="bgcolor=\"#D5F4FF\"";

	print "    <TR $bg_color>\n";
	print '        <TD align="right">', $num+1, "</TD>\n";
	print "        <TD>$name</TD>\n";
	print '        <TD align="right">',$score,"</TD>\n";
	print "        <TD>$com</TD>\n";
	print "        <TD><FONT size=-1>$date</FONT></TD>\n";
#	print "        <TD>$time</TD>\n";
	print "    </TR>\n";
	$num++;
    }

}

# \̃tb^[\
sub show_table_foot {
    print <<"EOF";
</TABLE>
<FONT size="-1">$ver<BR>
<BR>
<A href="http://www.biwa.ne.jp/~tabatan/">
΃ebNE~jQ[ŗVԃy[W</A>
</FONT>
</DIV>
EOF

}


sub get_time {
    ($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
    $year = 1900+$year;
    $datename = sprintf("%04d/%02d/%02d", $year, $mon+1, $mday);
    $datehead = sprintf("%04d%02d%02d", $year, $mon+1, $mday);
    $timename = sprintf("%02d:%02d", $hour, $min);
}
